SystemOrganization addCategory: #'JQWidgetBox-TimeSlider-Dev'!

JQWidgetExample subclass: #JQTimeSliderExample
	instanceVariableNames: 'startTime endTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQWidgetBox-TimeSlider-Dev'!

!JQTimeSliderExample commentStamp: 'PaulDeBruicker 6/29/2011 13:03' prior: 0!
this adapts the jQuery UI Slider to display and return times rather than values.  It is based on the code here:  

https://github.com/marcneuwirth/jquery.ui.timeslider

but I adapted it some to be able to have separate text inputs when using a range.  


12:00AM is represented by a slider value of 300 because the timeslider javascript library uses the Date() object but does not retain date or TimeZone information.  11:59 PM is represented by a slider value of 1739. 

I do not know but guess that the time offset should be different based on what time zone you run this in.  

 Each point in between is a minute.  So 1739-300 = 1439 and there are 1440 minutes in a 24 hr period.  clicking the submit buttons just returns the strings displayed in the text input boxes.  
!

!JQTimeSliderExample classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/26/2011 12:04'!
description
	^'Extends slider to show times rather than numbers'! !

!JQTimeSliderExample classSide methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/26/2011 12:04'!
shortName
	^'timeSlider'! !

!JQTimeSliderExample methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/29/2011 13:50'!
end: aValue
endTime:=(Time fromString: aValue).
! !

!JQTimeSliderExample methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/29/2011 13:46'!
initialize 
	super initialize .
	startTime:=Time fromString: '8:00 AM'.
	endTime:=Time fromString: '5:00 PM'.! !

!JQTimeSliderExample methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/26/2011 11:32'!
renderContentOn: html
	html heading level1; with:'Time Slider jQuery UI Plugin Demo'.
	self renderTimeOne: html.
	self renderTimeTwo: html.
	! !

!JQTimeSliderExample methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/29/2011 13:45'!
renderTimeOne: html
	(html div)
		class: 'slider';
		with: [ 
					html div id: 'slider1';
						script: ((html jQuery this timeSlider) orientation: 'vertical';
							min:300;
							max: 1739;
							start: startTime;
							step: 5;
							startTime:'#time1';
							sliderOptions).
					html form:[html textInput id: 'time1'; callback:[:val | self start: val].
					html submitButton id: 'schedule-submit1'; with:'Submit Time'].
			]! !

!JQTimeSliderExample methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/29/2011 13:45'!
renderTimeTwo: html
	html
		form: [ 
			(html div)
				class: 'slider';
				with: [ 
							(html textInput)
								id: 'start2';
								size: 6;
								callback: [ :val | self start: val ].
							(html div)
								id: 'slider2';
								script:
										((html jQuery this timeSlider)
												min: 300;
												max: 1739;
												start: startTime end: endTime;
												step: 5;
												startTime: '#start2';
												endTime: '#end';
												sliderOptions).
							(html textInput)
								id: 'end';
								size: 6;
								callback: [ :val | self end: val ].
							html submitButton with: 'Submit Time Range'.
						]]! !

!JQTimeSliderExample methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/29/2011 13:50'!
start: aValue
startTime:=(Time fromString: aValue)
! !

!JQTimeSliderExample methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/29/2011 12:51'!
style
	^'.slider{width:400px; float:left;}
.slider, #slider1, #slider2, table{margin:10px;}
#slider2{float:left;width:200px;} #start2{float:left;}'! !

!JQTimeSliderExample methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/29/2011 13:37'!
updateRoot: anHtmlRoot
		super updateRoot: anHtmlRoot.
		anHtmlRoot stylesheet url: 'http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.13/themes/smoothness/jquery-ui.css'.
		anHtmlRoot javascript url: self library / #jqueryuitimesliderminJs! !

!JQWidgetBoxDevelopmentLibrary methodsFor: '*jqwidgetbox-timeslider-dev' stamp: 'PaulDeBruicker 6/29/2011 13:14'!
jqueryuitimesliderJs
	^ '(function($) {  
    $.widget("ui.timeslider", {
        getTime: function(value){   
            var time = null,
                from = new Date(value * 60 * 1000),
                minutes = from.getMinutes(),
                hours = from.getHours();
            
            if (hours === 0) {
                hours = 12;
            }
        
            if (hours > 12) {
                hours = hours - 12;
                time = "PM";
            }
            else {
                time = "AM";   
            }
        
            if (minutes < 10) {
                minutes = "0" + minutes;
            }
        
            return hours + ":" + minutes + " " + time;
	
      },
        _slideTime: function (event, ui){
            var that = $(this),
                stTime = null,
                eTime = null;
            
            if(that.slider( "option", "range" )){
                stTime = that.timeslider(''getTime'',(that.slider("values", 0)));
                eTime = that.timeslider(''getTime'', that.slider("values", 1));
            
                 that.timeslider(''option'', ''startTime'').val(stTime);
		 that.timeslider(''option'', ''endTime'').val(eTime);
            }
            else {
                stTime = that.timeslider(''getTime'', that.slider("value"));
    
                that.timeslider(''option'', ''startTime'').val(stTime);
            }
        },
        _checkMax: function(event, ui) {
            var that = $(this);
        
            if(that.slider( "option", "range" )){
                var div = that.find(''div''),
                    size = that.slider("values", 1) - that.slider("values", 0);
                if( size >= 1435) {
		            div.addClass("ui-state-error");
                    that.timeslider(''option'', ''submitButton'').attr("disabled","disabled").addClass("ui-state-disabled");
                    that.timeslider(''option'', ''errorMessage'').text("Cannot be more than 24 hours");
	            }
		        else {	
                    div.removeClass("ui-state-error");
                    that.timeslider(''option'', ''submitButton'').attr("disabled",null).removeClass("ui-state-disabled");
                    that.timeslider(''option'', ''errorMessage'').text("");
                } 
            }
        },
        options: {
            sliderOptions: {},
            errorMessage: null,
            startTime: null,
	    endTime: null,
            submitButton: null,
            clickSubmit: null
            
        },
        _create: function() {
            var that = this,
                o = that.options,
                el = that.element;
                
                o.sliderOptions.slide = that._slideTime;
                o.sliderOptions.change = that._checkMax;
                o.sliderOptions.stop = that._slideTime;
                el.slider(o.sliderOptions);
                
                o.errorMessage = $(o.errorMessage);
                o.endTime = $(o.endTime);                
	    o.startTime = $(o.startTime);
                o.submitButton = $(o.submitButton).click(o.clickSubmit);
                
                
                that._slideTime.call(el);
        },
        _destroy: function() {
            this.element.remove();
        }
    });
})(jQuery);
    '! !
